
Block@[] blocks = {};
uint blocks_size = 0;
string lastBlockId = '';
uint items_size = 0;
string lastItemId = '';


bool getblocks() {
    CGameCtnChallenge@ rootMap = cast<CGameCtnChallenge>(GetApp().RootMap);
    if (rootMap is null) {
        blocks = {};
        return false;
    }
    Block@[] new_blocks = {};
    blocks_size = rootMap.Blocks.Length;
    lastBlockId = rootMap.Blocks[rootMap.Blocks.Length-1].IdName;
    items_size = rootMap.AnchoredObjects.Length;
    if (items_size > 0) {
        lastItemId = rootMap.AnchoredObjects[rootMap.AnchoredObjects.Length-1].IdName;
    } else {
        lastItemId = '';
    }

    for (uint i = 0; i < rootMap.Blocks.Length; i++) {
        if (rootMap.Blocks[i].BlockModel is null) {
            continue;}
        uint saveCheck = ShouldSaveBlock(rootMap.Blocks[i]);
        if (saveCheck > 0) {
            new_blocks.InsertLast(Block(rootMap.Blocks[i], saveCheck));
        }
        if (Time::get_Now() - startTime > 20) {
            yield();
            startTime = Time::get_Now();
            if (rootMap is null || GetApp().RootMap !is rootMap) {
                blocks = {};
                return false;}
        }
    }

    for (uint i = 0; i < rootMap.AnchoredObjects.Length; i++) {
        if (rootMap.AnchoredObjects[i].ItemModel is null) {
            continue;}
        uint saveCheck = ShouldSaveItem(rootMap.AnchoredObjects[i]);
        if (saveCheck > 0) {
            new_blocks.InsertLast(Block(rootMap.AnchoredObjects[i], saveCheck));
        }
        if (Time::get_Now() - startTime > 20) {
            yield();
            startTime = Time::get_Now();
            if (rootMap is null || GetApp().RootMap !is rootMap) {
                blocks = {};
                return false;}
        }
    }


    for (uint i = 0; i < new_blocks.Length; i++) {
        if (Time::get_Now() - startTime > 15) {
            yield();
            startTime = Time::get_Now();
            if (rootMap is null || GetApp().RootMap !is rootMap) {
                blocks = {};
                return false;}
        }
        // some blocks were confirmed as highlighted on ShouldSaveBlock
        if (!new_blocks[i].should_display) {
            new_blocks[i].should_display = ShouldHighlightBlock(new_blocks[i], new_blocks);
        }
    }

    blocks = new_blocks;
    return true;
}

bool hasChanged() {
    CGameCtnChallenge@ rootMap = cast<CGameCtnChallenge>(GetApp().RootMap);
    if (rootMap is null) {return true;}
    return !(blocks_size == rootMap.Blocks.Length && lastBlockId == rootMap.Blocks[rootMap.Blocks.Length-1].IdName && items_size == rootMap.AnchoredObjects.Length && ((rootMap.AnchoredObjects.Length == 0 && lastItemId == '') || (rootMap.AnchoredObjects.Length > 0 && lastItemId == rootMap.AnchoredObjects[rootMap.AnchoredObjects.Length-1].IdName)));
}
