
enum ShowName {
    Disabled,
    BlockName,
    SingleSurface,
    MultiSurface
}

[Setting name="Show custom block names" category="Custom blocks"]
ShowName Custom_showName = ShowName::Disabled;

[Setting name="Material (shared)" category="Custom blocks"]
string Custom_materialAll = "Tech";

[Setting name="Material (tech)" category="Custom blocks"]
string Custom_materialTech = "Tech";

[Setting name="Material (dirt)" category="Custom blocks"]
string Custom_materialDirt = "Tech";

[Setting name="Material (ice)" category="Custom blocks"]
string Custom_materialIce = "Tech";

[Setting name="Material (grass)" category="Custom blocks"]
string Custom_materialGrass = "Tech";

[Setting name="Material (plastic)" category="Custom blocks"]
string Custom_materialPlastic = "Tech";

[Setting name="Material (wood)" category="Custom blocks"]
string Custom_materialWood = "Tech";

[Setting name="Heavy ice" category="Custom blocks"]
bool Custom_HeavyIce = true;
[Setting name="Full open platfrom (including border)" category="Custom blocks"]
bool Custom_FullOpen = true;
[Setting name="Full rally dirt (including border)" category="Custom blocks"]
bool Custom_FullRallyDirt = true;

[Setting name="Window location" category="Custom blocks"]
nat2 Custom_windowPos = nat2(0, 0); // 0 0 is auto-scale

string Description(ShowName s) {
    switch(s) {
        case (ShowName::Disabled): {
            return 'Disabled';
        } case (ShowName::BlockName): {
            return 'Block Name';
        } case (ShowName::SingleSurface): {
            return 'All single surface';
        } case (ShowName::MultiSurface): {
            return 'Surface depending on original';
        }
    }
    return "";
}


void RenderBlockName() {
    if (Custom_showName == ShowName::Disabled) {return;}
    if (!(GetApp() is null ||
        GetApp().Editor is null ||
        cast<CGameEditorItem@>(GetApp().Editor) is null
        )) {
        CGameEditorItem@ editor = cast<CGameEditorItem@>(GetApp().Editor);
        if (!(
            editor.ItemModel is null ||
            cast<CGameBlockItem@>(editor.ItemModel.EntityModelEdition) is null)) {
            if (Custom_windowPos.x == 0 && Custom_windowPos.y == 0) {
                UI::SetNextWindowPos(int(Math::Round(float(950 * Draw::GetWidth())/(1920.f * UI::GetScale()))) - 250, int(Math::Round(float(760 * Draw::GetHeight())/(1080.f * UI::GetScale())))-20, UI::Cond::Always);
            } else {
                UI::SetNextWindowPos(Custom_windowPos.x, Custom_windowPos.y, UI::Cond::Always);
            }
            UI::SetNextWindowSize(500,40);
            if (UI::Begin("BlockName", UI::WindowFlags::NoTitleBar|UI::WindowFlags::NoResize|UI::WindowFlags::NoMove)) {
                CGameBlockItem@ blockItem = cast<CGameBlockItem@>(editor.ItemModel.EntityModelEdition);
                if (blockItem is null) {UI::End(); return;}
                string saveText = blockItem.ArchetypeBlockInfoId.GetName();

                if (Custom_showName == ShowName::SingleSurface) {
                    if (saveText.StartsWith("Platform")) {
                        saveText = saveText.Replace("Tech", Custom_materialAll);
                    } else if (saveText.StartsWith("Open")) {
                        if (Custom_FullOpen) {
                            saveText = saveText + "-" + Custom_materialAll;
                        } else {
                            saveText = saveText + "-" + Custom_materialAll + "-Light";
                        }
                    } else if (saveText.StartsWith("RoadTech") || saveText.StartsWith("RoadBump") || saveText.StartsWith("RoadDirt") || 
                    saveText.StartsWith("SnowRoad") || saveText.StartsWith("RallyCastleRoad") ||
                        saveText == "TrackWallToRoadTech" || saveText == "TrackWallToRoadDirt" || saveText == "TrackWallToRoadBump") {
                        saveText = saveText + "-" + Custom_materialAll + "-Light";
                    } else if (saveText.StartsWith("RoadIce")) {
                        if (Custom_HeavyIce) {
                            saveText = saveText + "-" + Custom_materialAll + "-Heavy";
                        } else {
                            saveText = saveText + "-" + Custom_materialAll + "-Light";
                        }
                    } else if (saveText.StartsWith("RallyRoadDirt")) {
                        if (Custom_FullRallyDirt) {
                            saveText = saveText.Replace("Dirt", Custom_materialAll);
                        } else {
                            saveText = saveText + "-" + Custom_materialAll + "-Light";
                        }
                    } else if (saveText.StartsWith("Canopy")) {
                        saveText = saveText + "-" + Custom_materialAll;
                    }
                } else if (Custom_showName == ShowName::MultiSurface) {
                    if (saveText.StartsWith("Platform")) {
                        if (saveText.StartsWith("PlatformTech")) {
                            saveText = saveText.Replace("Tech", Custom_materialTech);
                        }
                        if (saveText.StartsWith("PlatformDirt")) {
                            saveText = saveText.Replace("Dirt", Custom_materialDirt);
                        }
                        if (saveText.StartsWith("PlatformIce")) {
                            saveText = saveText.Replace("Ice", Custom_materialIce);
                        }
                        if (saveText.StartsWith("PlatformGrass")) {
                            saveText = saveText.Replace("Grass", Custom_materialGrass);
                        }
                        if (saveText.StartsWith("PlatformPlastic")) {
                            saveText = saveText.Replace("Plastic", Custom_materialPlastic);
                        }
                        if (saveText.StartsWith("PlatformWood")) {
                            saveText = saveText.Replace("Wood", Custom_materialWood);
                        }
                    } else if (saveText.StartsWith("Open")) {
                        if (Custom_FullOpen) {
                            if (saveText.StartsWith("OpenTech")) {
                                saveText = saveText + "-" + Custom_materialTech;
                            } else if (saveText.StartsWith("OpenDirt")) {
                                saveText = saveText + "-" + Custom_materialDirt;
                            } else if (saveText.StartsWith("OpenIce")) {
                                saveText = saveText + "-" + Custom_materialIce;
                            } else if (saveText.StartsWith("OpenGrass")) {
                                saveText = saveText + "-" + Custom_materialGrass;
                            } else if (saveText.StartsWith("OpenPlastic")) {
                                saveText = saveText + "-" + Custom_materialPlastic;
                            } else if (saveText.StartsWith("OpenWood")) {
                                saveText = saveText + "-" + Custom_materialWood;
                            }
                        } else {
                            if (saveText.StartsWith("OpenTech")) {
                                saveText = saveText + "-" + Custom_materialTech + "-Light";
                            } else if (saveText.StartsWith("OpenDirt")) {
                                saveText = saveText + "-" + Custom_materialDirt + "-Light";
                            } else if (saveText.StartsWith("OpenIce")) {
                                saveText = saveText + "-" + Custom_materialIce + "-Light";
                            } else if (saveText.StartsWith("OpenGrass")) {
                                saveText = saveText + "-" + Custom_materialGrass + "-Light";
                            } else if (saveText.StartsWith("OpenPlastic")) {
                                saveText = saveText + "-" + Custom_materialPlastic + "-Light";
                            } else if (saveText.StartsWith("OpenWood")) {
                                saveText = saveText + "-" + Custom_materialWood + "-Light";
                            }
                        }
                    } else if (saveText.StartsWith("RoadTechToRoadDirt")) {
                        saveText = saveText + "-" + Custom_materialTech + "To" + Custom_materialDirt + "-Light";
                    } else if (saveText.StartsWith("RoadTechToRoadBump")) {
                        saveText = saveText + "-" + Custom_materialTech + "-Light";
                    } else if (saveText.StartsWith("RoadTechToRoadIce")) {
                        if (Custom_HeavyIce) {
                            saveText = saveText + "-" + Custom_materialTech + "To" + Custom_materialIce + "-Heavy";
                        } else {
                            saveText = saveText + "-" + Custom_materialTech + "To" + Custom_materialIce + "-Light";
                        }
                    } else if (saveText.StartsWith("RoadTechToThemeSnowRoad")) {
                        saveText = saveText + "-" + Custom_materialTech + "To" + Custom_materialWood + "-Light";
                    } else if ((saveText.StartsWith("RoadTech") || saveText.StartsWith("RoadBump") || saveText.StartsWith("TrackWallToRoadTech") || saveText.StartsWith("TrackWallToRoadBump"))) {// && !saveText.StartsWith("RoadTechToThemeSnow")) {
                        saveText = saveText + "-" + Custom_materialTech + "-Light";
                    } else if (saveText.StartsWith("RoadDirt") || saveText.StartsWith("RallyCastleRoad") || saveText.StartsWith("TrackWallToRoadDirt")) {
                        saveText = saveText + "-Sand-Light";
                    } else if (saveText.StartsWith("RoadIce") || saveText.StartsWith("TrackWallToRoadIce")) {
                        if (Custom_HeavyIce) {
                            saveText = saveText + "-" + Custom_materialIce + "-Heavy";
                        } else {
                            saveText = saveText + "-" + Custom_materialIce + "-Light";
                        }
                    } else if (saveText.StartsWith('SnowRoad') || saveText.StartsWith("TrackWallToThemeSnowRoad")) {
                        saveText = saveText + "-" + Custom_materialWood + "-Light";
                    } else if (saveText.StartsWith("RallyRoadDirt")) {
                        if (Custom_FullRallyDirt) {
                            saveText = saveText.Replace("Dirt", Custom_materialDirt);
                        } else {
                            saveText = saveText + "-" + Custom_materialDirt + "-Light";
                        }
                    } else if (saveText.StartsWith("Canopy")) {
                        saveText = saveText + "-"+Custom_materialPlastic;
                    }
                }


                if (UI::Button(saveText)) {
                    IO::SetClipboard(saveText);
                    editor.FileSaveAs();
                }
                UI::SameLine();
                if (UI::Button("exit editor")) {
                    editor.Exit();
                }
                UI::SameLine();
                UI::Text("Altered Campaign Helper");
            }
            UI::End();
        }
    }
}

void SetCustomSettings(const string &in surface) {

    if (surface == "Magnet") {
        Custom_showName = ShowName::SingleSurface;
        Custom_materialAll = "Magnet";
        Custom_HeavyIce = true;
        Custom_FullOpen = false;
        Custom_FullRallyDirt = true;
        return;
    } else if (surface == "Penalty") {
        Custom_showName = ShowName::MultiSurface;
        Custom_materialTech = "PGrass";
        Custom_materialDirt = "Sand";
        Custom_materialIce = "Snow";
        Custom_materialGrass = "PGrass";
        Custom_materialPlastic = "Rubber";
        Custom_materialWood = "Sand";
        Custom_HeavyIce = false;
        Custom_FullOpen = false;
        Custom_FullRallyDirt = true;
        return;
    } else if (surface == "Wood") {
        Custom_showName = ShowName::SingleSurface;
        Custom_materialAll = "Wood";
        Custom_HeavyIce = true;
        Custom_FullOpen = true;
        Custom_FullRallyDirt = true;
        return;
    }
}