
uint currentFiltersId = 1;
bool shouldRefresh = false;

uint64 startTime;
uint64 lastRefresh = 0;

uint highlighted = 0;

bool enabled;
bool showDots = true;
bool ineditor = false;
#if GET_CP_DATA
bool a = false;
#endif
// in map and editor
bool inmap_editor = false;


void Main() {
    checkNoFilters();
    shouldRefresh = true;
    startTime = Time::get_Now();
    while (true) {
        if (GetApp() is null) {
            yield();
            startTime = Time::get_Now();
            continue;
        }
#if GET_CP_DATA
        if (!a && GetApp().CurrentPlayground !is null && GetApp().RootMap !is null) {
            addCpCount();
            a = true;
        }
        else if (a && GetApp().CurrentPlayground is null && GetApp().RootMap is null) {a = false;}
#endif

        if (cast<CGameCtnEditorFree>(GetApp().Editor) !is null) {
            if (!ineditor) {
                onOpenEditor();}
        } else {
            if (ineditor) {
                onCloseEditor();}
        }
        if (GetApp().RootMap is null || cast<CGameCtnEditorFree>(GetApp().Editor) is null) {
            if (blocks.Length > 0) {blocks = {};}
            yield();
            startTime = Time::get_Now();
            continue;
        } else if (!enabled) {
            if (blocks.Length > 0) {blocks = {};}
            // yield();
            // startTime = Time::get_Now();
            // can't continue so cp tracker works when not enabled
        }
        if (Time::get_Now() - lastRefresh > 100) {
            bool playground = GetApp().CurrentPlayground !is null;
            if (!playground && hasChanged()) {
                shouldRefresh = true;
            } else {
                lastRefresh = Time::get_Now();
                if (!inmap_editor && playground) {
                    checkCheckpoints();
                    inmap_editor = true;
                } else if (inmap_editor && !playground){inmap_editor = false;}
            }
        }
        if (shouldRefresh) {
            uint workingFiltersId = currentFiltersId;
            getblocks();
            shouldRefresh = false;
            lastRefresh = Time::get_Now();
            if (workingFiltersId != currentFiltersId) {
                shouldRefresh = true;
            }
        } else {
            yield();
            startTime = Time::get_Now();
        }
    }
}

void checkNoFilters() {
    if (RoadTech || RoadDirt || RoadBump || RoadIce || RoadWood || RoadWater || TrackWall || RallyCastleRoad || RallyRoadDirt||
        PlatformTech || PlatformDirt || PlatformIce || PlatformGrass || PlatformPlastic || PlatformWater || DecoWall || Structure || StructureSupport || 
        OpenTech || OpenDirt || OpenIce || OpenGrass || Canopy ||
        ItemPlastic || MovingObstacles || ItemWood || ItemDirt || ItemRamps ||
        Boosters || EffectBlocks || IsCheckpoint || CheckpointNoGate ||
        CPfull || Hole || PoolHunter || Manslaughter ||
        Ground) {
        enabled = true;
    } else {
        enabled = false;
        blocks = {};
    }
}


void Render() {
    RenderBlockName();
    RenderUI();
    highlighted = 0;
    if (!showDots) {return;}
    if (blocks.Length == 0) {return;}
    CGameCtnChallenge@ rootMap = cast<CGameCtnChallenge>(GetApp().RootMap);
    if (rootMap is null || cast<CGameCtnEditorFree>(GetApp().Editor) is null) {blocks = {}; return;}

    nvg::Reset();
    for (uint i = 0; i < blocks.Length; i++) {
        if (blocks[i].should_display) {
            blocks[i].renderDot();
            highlighted++;
        }
        if (showDebug) {
            blocks[i].renderDot_Debug();
        }
    }
}
