
bool showInterface = false;

[Setting name="Show highlights count when overlay hidden"]
bool showWithoutUI = false;

string GetDisplayName() {
    string info;
    if (enabled && !(cast<CGameCtnEditorFree>(GetApp().Editor) is null)) {
        if (highlighted == 0) {
            info = ":  \\$4f4" + highlighted;
        } else {
            info = ":  \\$f44" + highlighted;
        }
    } else {
        info = "";
    }
    if (colorDisplayName) {
        return "\\$f88 Altered Campaign Helper" + info;
    } else {
        return "\\$z Altered Campaign Helper" + info;
    }

}

void RenderMenu() {
    if (GetApp() is null) {showInterface = false; return;}
    bool disabled = false;
    if (cast<CGameCtnEditorFree>(GetApp().Editor) is null && cast<CGameEditorItem>(GetApp().Editor) is null) {UI::BeginDisabled(); disabled=true;}
    if (colorDisplayName) {
        if (UI::MenuItem("\\$29e" + Icons::Random + GetDisplayName(), "", showInterface)) {
            showInterface = !showInterface;
        }
    } else {
        if (UI::MenuItem("\\$29e" + Icons::Random + GetDisplayName(), "", showInterface)) {
            showInterface = !showInterface;
        }
    }
    if (disabled) {
        UI::EndDisabled();
    }
}

const vec2 buttonSize = vec2(Math::Floor(20. * UI::GetScale()), Math::Floor(20. * UI::GetScale()));


uint currentTab = 0;
vec4 surfaceColor = vec4(0, 0.5, 0, 1), listColor = vec4(0.5, 0.5, 0, 1), miscColor = vec4(0.5, 0, 0.5, 1), customColor = vec4(0, 0.5, 0.5, 1);//, clubColor = vec4(0, 0, 0.9, 1);

void RenderUI() {
    if (!showInterface) {return;}
    if (!UI::IsOverlayShown() && !showWithoutUI) {return;}
    if (GetApp() is null) {showInterface = false; return;}
    if (cast<CGameCtnEditorFree>(GetApp().Editor) is null && cast<CGameEditorItem>(GetApp().Editor) is null) {showInterface = false; return;}

    UI::SetNextWindowPos(100, 100, UI::Cond::Once);
    
    if (!UI::IsOverlayShown()) {
        UI::SetNextWindowSize(320, 1, UI::Cond::Always);
        UI::Begin(GetDisplayName() + '###Altered Campaign Helper', showInterface, UI::WindowFlags::NoResize);
        UI::End(); // will show title with highlights count but nothing else
        return;
    }

    UI::SetNextWindowSize(320, 0, UI::Cond::Always);

    if (UI::Begin(GetDisplayName() + '###Altered Campaign Helper', showInterface, UI::WindowFlags::NoResize)) {
        // UI::Text("" + showInterface);
        UI::BeginTabBar("tab bar", UI::TabBarFlags::NoCloseWithMiddleMouseButton);
        UI::PushStyleColor(UI::Col::Tab, surfaceColor * vec4(0.5, 0.5, 0.5, 0.75));
        UI::PushStyleColor(UI::Col::TabHovered, surfaceColor * vec4(1.2, 1.2, 1.2, 0.85));
        UI::PushStyleColor(UI::Col::TabActive, surfaceColor);
        if (UI::BeginTabItem("Surfaces")) {
            currentTab = 0;
            UI::Text('Select surfaces to highlight');
            if (UI::Button('Refresh')) {
                shouldRefresh = true;
            }
            UI::SameLine();
            UI::Text('' + blocks.Length + ' blocks; ' + highlighted + ' dots');

            bool newValue;
            newValue = UI::Checkbox('Road Tech', RoadTech);
            if (newValue != RoadTech) {
                RoadTech = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Road Bump', RoadBump);
            if (newValue != RoadBump) {
                RoadBump = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform Tech', PlatformTech);
            if (newValue != PlatformTech) {
                PlatformTech = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform Tech with penalty', OpenTech);
            if (newValue != OpenTech) {
                OpenTech = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Road Dirt', RoadDirt);
            if (newValue != RoadDirt) {
                RoadDirt = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Castle Dirt', RallyCastleRoad);
            if (newValue != RallyCastleRoad) {
                RallyCastleRoad = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform Dirt', PlatformDirt);
            if (newValue != PlatformDirt) {
                PlatformDirt = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform Dirt with penalty', OpenDirt);
            if (newValue != OpenDirt) {
                OpenDirt = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Dirt with sloped penalty', RallyRoadDirt);
            if (newValue != RallyRoadDirt) {
                RallyRoadDirt = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Item Dirt', ItemDirt);
            if (newValue != ItemDirt) {
                ItemDirt = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Road Ice', RoadIce);
            if (newValue != RoadIce) {
                RoadIce = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform Ice', PlatformIce);
            if (newValue != PlatformIce) {
                PlatformIce = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform Ice with penalty', OpenIce);
            if (newValue != OpenIce) {
                OpenIce = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Platform Grass', PlatformGrass);
            if (newValue != PlatformGrass) {
                PlatformGrass = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform Grass with penatly', OpenGrass);
            if (newValue != OpenGrass) {
                OpenGrass = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Platform Plastic', PlatformPlastic);
            if (newValue != PlatformPlastic) {
                PlatformPlastic = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Canopy', Canopy);
            if (newValue != Canopy) {
                Canopy = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Item Plastic (and metal pipes)', ItemPlastic);
            if (newValue != ItemPlastic) {
                ItemPlastic = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Moving Obstacles', MovingObstacles);
            if (newValue != MovingObstacles) {
                MovingObstacles = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Road Wood', RoadWood);
            if (newValue != RoadWood) {
                RoadWood = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Item Wood', ItemWood);
            if (newValue != ItemWood) {
                ItemWood = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Ramps (items)', ItemRamps);
            if (newValue != ItemRamps) {
                ItemRamps = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Road Water', RoadWater);
            if (newValue != RoadWater) {
                RoadWater = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform Water', PlatformWater);
            if (newValue != PlatformWater) {
                PlatformWater = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Track support (top)', TrackWall);
            if (newValue != TrackWall) {
                TrackWall = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform support (top)', DecoWall);
            if (newValue != DecoWall) {
                DecoWall = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Structure (narrow beams)', Structure);
            if (newValue != Structure) {
                Structure = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Structure support (side)', StructureSupport);
            if (newValue != StructureSupport) {
                StructureSupport = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Boosters', Boosters);
            if (newValue != Boosters) {
                Boosters = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Effect Blocks', EffectBlocks);
            if (newValue != EffectBlocks) {
                EffectBlocks = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Checkpoints', IsCheckpoint);
            if (newValue != IsCheckpoint) {
                IsCheckpoint = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Checkpoints without effect ring', CheckpointNoGate);
            if (newValue != CheckpointNoGate) {
                CheckpointNoGate = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('CPfull alteration', CPfull);
            if (newValue != CPfull) {
                CPfull = newValue;
                shouldRefresh = true;}
            // newValue = UI::Checkbox('Platform to Road without checkpoint overlay', PlatformToRoad_NoCP);
            // if (newValue != PlatformToRoad_NoCP) {
            //     PlatformToRoad_NoCP = newValue;
            //     shouldRefresh = true;}
            newValue = UI::Checkbox('Hole alteration', Hole);
            if (newValue != Hole) {
                Hole = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Pool hunters*', PoolHunter);
            if (newValue != PoolHunter) {
                PoolHunter = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Manslaughter*', Manslaughter);
            if (newValue != Manslaughter) {
                Manslaughter = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Ground mode blocks', Ground);
            if (newValue != Ground) {
                Ground = newValue;
                shouldRefresh = true;}

            UI::EndTabItem();
        }
        UI::PopStyleColor(3);
        UI::PushStyleColor(UI::Col::Tab, listColor * vec4(0.5, 0.5, 0.5, 0.75));
        UI::PushStyleColor(UI::Col::TabHovered, listColor * vec4(1.2, 1.2, 1.2, 0.85));
        UI::PushStyleColor(UI::Col::TabActive, listColor);
        if (UI::BeginTabItem("Highlights")) {
            currentTab = 1;
            if (UI::Button('Refresh')) {
                shouldRefresh = true;
            }
            UI::SameLine();
            UI::Text('' + blocks.Length + ' blocks; ' + highlighted + ' dots');
            for(uint i = 0; i < blocks.Length; i++) {
                if (!blocks[i].should_display) {continue;}
                if (UI::Button(Icons::Search + '##' + tostring(i), buttonSize)) {FocusCamera(blocks[i].midpoint);}
                UI::SameLine();
                UI::Text('<' + Math::Round(blocks[i].midpoint.x) + ', ' + Math::Round(blocks[i].midpoint.y) + ', ' + Math::Round(blocks[i].midpoint.z) + '> ' + blocks[i].name);
            }
            UI::EndTabItem();
        }
        UI::PopStyleColor(3);
        UI::PushStyleColor(UI::Col::Tab, miscColor * vec4(0.5, 0.5, 0.5, 0.75));
        UI::PushStyleColor(UI::Col::TabHovered, miscColor * vec4(1.2, 1.2, 1.2, 0.85));
        UI::PushStyleColor(UI::Col::TabActive, miscColor);
        if (UI::BeginTabItem("Misc")) {
            currentTab = 2;
            bool disabled = false;
            autoColor = UI::Checkbox('###autoColor', autoColor);
            UI::SameLine();
            UI::TextWrapped('Auto select colour when opening a campaign (or altered campaign) map in editor');
            cpWarning = UI::Checkbox('###cpWarning', cpWarning);
            UI::SameLine();
            UI::TextWrapped('Warn if the checkpoint count is different to the unaltered map \n(when entering drive mode)');
            colorDisplayName = UI::Checkbox('###nameColor', colorDisplayName);
            UI::SameLine();
            UI::TextWrapped('Color the name in plugins list');
            UI::Text('Variant highlight mode:');
            if (UI::BeginCombo('##0', VariantColorName(variantColor), UI::ComboFlags::None)) {
                if (UI::Selectable(VariantColorName(VariantColorOptions::Disabled), variantColor == VariantColorOptions::Disabled, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::Disabled;
                }
                if (UI::Selectable(VariantColorName(VariantColorOptions::Ghost), variantColor == VariantColorOptions::Ghost, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::Ghost;
                }
                if (UI::Selectable(VariantColorName(VariantColorOptions::NotGhost), variantColor == VariantColorOptions::NotGhost, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::NotGhost;
                }
                if (UI::Selectable(VariantColorName(VariantColorOptions::Free), variantColor == VariantColorOptions::Free, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::Free;
                }
                if (UI::Selectable(VariantColorName(VariantColorOptions::NotFree), variantColor == VariantColorOptions::NotFree, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::NotFree;
                }
                if (UI::Selectable(VariantColorName(VariantColorOptions::Ground), variantColor == VariantColorOptions::Ground, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::Ground;
                }
                if (UI::Selectable(VariantColorName(VariantColorOptions::NotGround), variantColor == VariantColorOptions::NotGround, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::NotGround;
                }
                if (UI::Selectable(VariantColorName(VariantColorOptions::NotNormal), variantColor == VariantColorOptions::NotNormal, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::NotNormal;
                }
                if (UI::Selectable(VariantColorName(VariantColorOptions::Normal), variantColor == VariantColorOptions::Normal, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::Normal;
                }
                UI::EndCombo();
                disabled = true;
                UI::BeginDisabled();
            }
            checkOverlayHitbox = UI::Checkbox('###overlayhitbox', checkOverlayHitbox);
            UI::SameLine();
            UI::TextWrapped('Require hitbox match on custom overlays (may have issues on support mode tilt/slope blocks)\n(not checked on checkpoints)');
            showDebug = UI::Checkbox('###debugDots', showDebug);
            UI::SameLine();
            UI::TextWrapped('Show debug position dots');
            showWithoutUI = UI::Checkbox('###noUI', showWithoutUI);
            UI::SameLine();
            UI::TextWrapped('Show highlights when Openplanet overlay hidden');

#if GET_CP_DATA
            if (UI::Button('save CP counts')) {
                saveCpCounts();
            }
#endif

            if (disabled) {
                UI::EndDisabled();
            }
            UI::EndTabItem();
        }
        UI::PopStyleColor(3);
        UI::PushStyleColor(UI::Col::Tab, customColor * vec4(0.5, 0.5, 0.5, 0.75));
        UI::PushStyleColor(UI::Col::TabHovered, customColor * vec4(1.2, 1.2, 1.2, 0.85));
        UI::PushStyleColor(UI::Col::TabActive, customColor);
        if (UI::BeginTabItem("Custom Blocks")) {
            currentTab = 3;
            bool disabled = false;
            UI::TextWrapped("Provides a popup in block editor that allows you to copy the name of the current block, with optional changes for a particular alteration");
            
            UI::Text("Display style");
            UI::SameLine();
            if (UI::BeginCombo("##Display style", Description(Custom_showName), UI::ComboFlags::None)) {
                if (UI::Selectable(Description(ShowName::Disabled), Custom_showName == ShowName::Disabled, UI::SelectableFlags::None)) {
                    Custom_showName = ShowName::Disabled;
                }
                if (UI::Selectable(Description(ShowName::BlockName), Custom_showName == ShowName::BlockName, UI::SelectableFlags::None)) {
                    Custom_showName = ShowName::BlockName;
                }
                if (UI::Selectable(Description(ShowName::SingleSurface), Custom_showName == ShowName::SingleSurface, UI::SelectableFlags::None)) {
                    Custom_showName = ShowName::SingleSurface;
                }
                if (UI::Selectable(Description(ShowName::MultiSurface), Custom_showName == ShowName::MultiSurface, UI::SelectableFlags::None)) {
                    Custom_showName = ShowName::MultiSurface;
                }
                UI::EndCombo();
                disabled = true;
                UI::BeginDisabled();
            }
            UI::Text("Presets");
            UI::SameLine();
            if (UI::BeginCombo("##Presets", "click to show")) {
                if (UI::Selectable("Magnet (@ArEyeses)", false, UI::SelectableFlags::None)) {
                    SetCustomSettings("Magnet");
                }
                if (UI::Selectable("Penalty (@ArEyeses)", false, UI::SelectableFlags::None)) {
                    SetCustomSettings("Penalty");
                }
                if (UI::Selectable("Wood (@BedsideDraw)", false, UI::SelectableFlags::None)) {
                    SetCustomSettings("Wood");
                }
                UI::EndCombo();
                disabled = true;
                UI::BeginDisabled();
            }
            UI::TextWrapped("Assumes you are using 'light' method where borders are excluded from the custom block");
            UI::SetCursorPos(vec2(UI::GetCursorPos().x, UI::GetCursorPos().y-8));
            UI::Markdown("[Like used here](https://item.mania.exchange/set/view/11164)");

            if (Custom_showName == ShowName::SingleSurface) {
                UI::Text("All surfaces become");
                UI::SameLine();
                UI::SetCursorPos(vec2(160 * UI::GetScale(), UI::GetCursorPos().y));
                UI::SetNextItemWidth(128);
                Custom_materialAll = UI::InputText("##Material", Custom_materialAll);
            } else if (Custom_showName == ShowName::MultiSurface) {
                UI::Text("Tech surfaces become");
                UI::SameLine();
                UI::SetCursorPos(vec2(160 * UI::GetScale(), UI::GetCursorPos().y));
                UI::SetNextItemWidth(128);
                Custom_materialTech = UI::InputText("##Material tech", Custom_materialTech);
                UI::Text("Dirt surfaces become");
                UI::SameLine();
                UI::SetCursorPos(vec2(160 * UI::GetScale(), UI::GetCursorPos().y));
                UI::SetNextItemWidth(128);
                Custom_materialDirt = UI::InputText("##Material dirt", Custom_materialDirt);
                UI::Text("Ice surfaces become");
                UI::SameLine();
                UI::SetCursorPos(vec2(160 * UI::GetScale(), UI::GetCursorPos().y));
                UI::SetNextItemWidth(128);
                Custom_materialIce = UI::InputText("##Material ice", Custom_materialIce);
                UI::Text("Grass surfaces become");
                UI::SameLine();
                UI::SetCursorPos(vec2(160 * UI::GetScale(), UI::GetCursorPos().y));
                UI::SetNextItemWidth(128);
                Custom_materialGrass = UI::InputText("##Material grass", Custom_materialGrass);
                UI::Text("Plastic surfaces become");
                UI::SameLine();
                UI::SetCursorPos(vec2(160 * UI::GetScale(), UI::GetCursorPos().y));
                UI::SetNextItemWidth(128);
                Custom_materialPlastic = UI::InputText("##Material plastic", Custom_materialPlastic);
                UI::Text("Wood surfaces become");
                UI::SameLine();
                UI::SetCursorPos(vec2(160 * UI::GetScale(), UI::GetCursorPos().y));
                UI::SetNextItemWidth(128);
                Custom_materialWood = UI::InputText("##Material wood", Custom_materialWood);
            }
            if (Custom_showName == ShowName::SingleSurface || Custom_showName == ShowName::MultiSurface) {
                Custom_HeavyIce = UI::Checkbox("Use heavy blocks for ice instead", Custom_HeavyIce);
                Custom_FullOpen = UI::Checkbox("Use full blocks for open platforms", Custom_FullOpen);
                if (UI::IsItemHovered()) {
                    UI::SetNextWindowSize(256, 0, UI::Cond::Always);
                    UI::BeginTooltip();
                    UI::TextWrapped("If you're using custom blocks that include each penalty surface instead of using 'light' blocks that can be placed over any surface");
                    UI::EndTooltip();
                }
                Custom_FullRallyDirt = UI::Checkbox("Use full blocks for rally road dirt", Custom_FullRallyDirt);
                if (UI::IsItemHovered()) {
                    UI::SetNextWindowSize(256, 0, UI::Cond::Always);
                    UI::BeginTooltip();
                    UI::TextWrapped("If you're using custom blocks that include the penalty grass instead of using 'light' blocks with only the dirt part");
                    UI::EndTooltip();
                }
            }

            if (disabled) {
                UI::EndDisabled();
            }
            UI::EndTabItem();
        }
        UI::PopStyleColor(3);
        UI::EndTabBar();
    }
    if (shouldRefresh) {
        checkNoFilters();
    }
    UI::End();
}

void FocusCamera(vec3 pos) {
    CGameCtnEditorFree@ editor = cast<CGameCtnEditorFree>(GetApp().Editor);
    CGameControlCameraEditorOrbital@ camera = editor.OrbitalCameraControl;
    if (camera is null) {return;}
    camera.m_TargetedPosition = pos;
    editor.ButtonZoomInOnClick();
    editor.ButtonZoomOutOnClick();
}